#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "makeImage.h"


#define  SWAP_16(x) (((x<<8) & 0xFF00) | ((x>>8) & 0x00FF))

unsigned short cal_checksum(char *image,int size) {

	unsigned short checksum = 0;
	unsigned char *pt=image;
	int i=0;
	
	while(i++<size)
		checksum+=*(pt++);
	printf("checksum = 0x%04X\n",checksum);
	return checksum;
}
int my_read_file(char *filename,char *buf,int size)
{
	FILE *fp;
	int len=0;
	if((fp=fopen(filename,"rb"))==NULL){
		fprintf(stderr,"Error opening %s for output\n",filename);
		exit(-1);
	}
	fseek(fp,0,SEEK_END);
	len=ftell(fp);
	
	if(len > size){
		fclose(fp);
		fprintf(stderr,"Sorry, %s must less than %d\n", filename,size);
		exit(-1);
	}
	fseek(fp, 0L, SEEK_SET);
	len=fread(buf,1,size,fp);
	fclose(fp);
	printf("%s read %d kbytes maximum %d kbytes\n",filename,len/1024,size/1024);
	return len;
}

int main(int argc,char **argv)
{
	char image[IMAGE_SIZE];
	char fs[ROOTFS_SIZE];
	char fill[1]={0x00};
	FILE	*fp;
	int 	fs_len=0;
	sercomm_pid_t *fw_pid;
	unsigned short chksum=0;

	memset(image,0xff,sizeof(image));
	memset(fs,0xff,sizeof(fs));

        if (argc != 4){
                printf("Usage: %s outImage inImage fs\n", argv[0]);
                return -1;
        }
	my_read_file(argv[2],(char *)&image,sizeof(image));
	
	fw_pid=(sercomm_pid_t *)(&image[PID_OFFSET]);

	if(fw_pid->hw_id[0]!='Y'
		|| fw_pid->hw_id[1]!='L'
		|| fw_pid->hw_id[2]!='8'
		|| fw_pid->hw_id[3]!='7'
		|| fw_pid->hw_id[4]!='2'
		|| fw_pid->hw_id[5]!='0'){
                printf("PID Error !!! Image Error!\n");
                return -1;
        }
#if 0
	chksum = SWAP_16(*((unsigned short *)(&image[CHKSUM_OFFSET])));
	printf("CHKSUM:%X\n", chksum);
#endif

	my_read_file(argv[3],(char *)&fs,sizeof(fs));

	printf("fs size =%d\n", sizeof(fs));

	memcpy((char *)&image[ROOTFS_OFFSET], (char *)&fs, sizeof(fs));

	fs_len = ROOTFS_SIZE+KFS_SIZE+PID_SIZE;
        printf("fs_len = 0x%x: %dK\n",fs_len,fs_len/1024);
	*((int *)&image[PID_OFFSET+128]) = fs_len; 
	*((unsigned short *)&image[PID_OFFSET+144]) = cal_checksum(&image[ROOTFS_OFFSET],fs_len);
	
	
	/* write image */
	fp=fopen(argv[1],"wb");	
	if(fp==NULL){
		fprintf(stderr,"Error opening %s for output\n",argv[0]);
		return -1;
		
	}
	fwrite(image,IMAGE_SIZE,1,fp);
	
	if (((IMAGE_SIZE) % 2) != 0)
		fwrite(fill,1,1,fp);	

	fclose(fp);
	return 0;

}
